using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Diagnostics;
using SHDocVw;

namespace BBSViewer
{
	/// <summary>
	/// Form_Main ժҪ˵
	/// </summary>
	public class Form_Main : System.Windows.Forms.Form
	{
		private string section_filename;
		private string list_filename;
		private Article_List article_list;
		private bool splitter_V_moved;
		public Form logo;

		private System.Windows.Forms.MainMenu mainMenu_Default;
		private System.Windows.Forms.MenuItem menuItem_File;
		private System.Windows.Forms.MenuItem menuItem_Exit;
		private System.Windows.Forms.MenuItem menuItem_Help;
		private System.Windows.Forms.MenuItem menuItem_About;
		private System.Windows.Forms.Panel panel_Guide;
		private System.Windows.Forms.TabControl tabControl_Guide;
		private System.Windows.Forms.TabPage tabPage_Online;
		private System.Windows.Forms.TreeView treeView_Online;
		private System.Windows.Forms.TabPage tabPage_Offline;
		private System.Windows.Forms.TreeView treeView_Offline;
		private System.Windows.Forms.Splitter splitter_V;
		private System.Windows.Forms.Panel panel_List;
		private System.Windows.Forms.Splitter splitter_H;
		private System.Windows.Forms.StatusBar statusBar;
		private System.Windows.Forms.MenuItem menuItem_Tool;
		private System.Windows.Forms.MenuItem menuItem_Update_Section;
		private System.Windows.Forms.ImageList imageList_TreeView;
		private System.Windows.Forms.GroupBox groupBox_sType;
		private System.Windows.Forms.RadioButton radioButton_sNormal;
		private System.Windows.Forms.RadioButton radioButton_sExcerption;
		private System.Windows.Forms.ListView listView_List;
		private System.Windows.Forms.ColumnHeader columnHeader_Title;
		private System.Windows.Forms.ColumnHeader columnHeader_ID;
		private System.Windows.Forms.ColumnHeader columnHeader_Nickname;
		private System.Windows.Forms.ColumnHeader columnHeader_ViewCount;
		private System.Windows.Forms.ColumnHeader columnHeader_ReplyCount;
		private System.Windows.Forms.ColumnHeader columnHeader_LastReply;
		private System.Windows.Forms.Panel panel_Search;
		private System.Windows.Forms.TextBox textBox_Search;
		private System.Windows.Forms.ToolBar toolBar_List;
		private System.Windows.Forms.ToolBarButton toolBarButton_First;
		private System.Windows.Forms.ToolBarButton toolBarButton_Previous;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_1;
		private System.Windows.Forms.ToolBarButton toolBarButton_Next;
		private System.Windows.Forms.ToolBarButton toolBarButton_Last;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_2;
		private System.Windows.Forms.ToolBarButton toolBarButton_Go;
		private System.Windows.Forms.ContextMenu contextMenu_Page;
		public System.Windows.Forms.ImageList imageList_ToolBar_List;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_3;
		private System.Windows.Forms.Button button_Find;
		private System.Windows.Forms.Label label_SectionTitle;
		private System.Windows.Forms.Label label_PageInfo;
		private System.Windows.Forms.Label label_Search;
		private System.Windows.Forms.ImageList imageList_TabPage;
		private System.Windows.Forms.ImageList imageList_ToolBar_Content;
		private System.Windows.Forms.ToolBarButton toolBarButton_Refresh_List;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_4;
		private System.Windows.Forms.Panel panel_Title;
		private System.Windows.Forms.ToolBar toolBar_Content;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_5;
		private System.Windows.Forms.ToolBarButton toolBarButton_Open;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_6;
		private System.Windows.Forms.ToolBarButton toolBarButton_Refresh_Content;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_7;
		private System.Windows.Forms.ToolBarButton toolBarButton_Browser;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_8;
		private System.Windows.Forms.ToolBarButton toolBarButton_Close;
		private System.Windows.Forms.Label label_Title;
		private System.Windows.Forms.MenuItem menuItem_Website;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem_Bug;
		private System.Windows.Forms.TabControl tabControl_Content;
		private System.Windows.Forms.ToolBarButton toolBarButton_FullScreen;
		private System.Windows.Forms.ToolBarButton toolBarButton_Separator_9;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem_Option;
		private System.Windows.Forms.MenuItem menuItem_Software_Upgrade;
		private System.Windows.Forms.ToolBarButton toolBarButton_New;
		private System.Windows.Forms.ToolBarButton toolBarButton_Reply;
		private System.Windows.Forms.GroupBox groupBox_Reload;
		private System.Windows.Forms.Button button_Reload;
		private System.Windows.Forms.ImageList imageList_TopicList;
		private System.Windows.Forms.StatusBarPanel statusBarPanel_Process;
		private System.Windows.Forms.StatusBarPanel statusBarPanel_Position;
		private System.ComponentModel.IContainer components;

		public Form_Main()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
			this.section_filename = GV.app_dir + "\\Section.xml";
			this.list_filename = GV.temp_dir + "\\List.xml";

			article_list = new Article_List();
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form_Main));
			this.statusBar = new System.Windows.Forms.StatusBar();
			this.mainMenu_Default = new System.Windows.Forms.MainMenu();
			this.menuItem_File = new System.Windows.Forms.MenuItem();
			this.menuItem_Exit = new System.Windows.Forms.MenuItem();
			this.menuItem_Tool = new System.Windows.Forms.MenuItem();
			this.menuItem_Update_Section = new System.Windows.Forms.MenuItem();
			this.menuItem_Software_Upgrade = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem_Option = new System.Windows.Forms.MenuItem();
			this.menuItem_Help = new System.Windows.Forms.MenuItem();
			this.menuItem_Website = new System.Windows.Forms.MenuItem();
			this.menuItem_Bug = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem_About = new System.Windows.Forms.MenuItem();
			this.panel_Guide = new System.Windows.Forms.Panel();
			this.tabControl_Guide = new System.Windows.Forms.TabControl();
			this.tabPage_Online = new System.Windows.Forms.TabPage();
			this.groupBox_sType = new System.Windows.Forms.GroupBox();
			this.radioButton_sExcerption = new System.Windows.Forms.RadioButton();
			this.radioButton_sNormal = new System.Windows.Forms.RadioButton();
			this.treeView_Online = new System.Windows.Forms.TreeView();
			this.imageList_TreeView = new System.Windows.Forms.ImageList(this.components);
			this.tabPage_Offline = new System.Windows.Forms.TabPage();
			this.groupBox_Reload = new System.Windows.Forms.GroupBox();
			this.button_Reload = new System.Windows.Forms.Button();
			this.treeView_Offline = new System.Windows.Forms.TreeView();
			this.splitter_V = new System.Windows.Forms.Splitter();
			this.panel_List = new System.Windows.Forms.Panel();
			this.listView_List = new System.Windows.Forms.ListView();
			this.columnHeader_ID = new System.Windows.Forms.ColumnHeader();
			this.columnHeader_Title = new System.Windows.Forms.ColumnHeader();
			this.columnHeader_Nickname = new System.Windows.Forms.ColumnHeader();
			this.columnHeader_ViewCount = new System.Windows.Forms.ColumnHeader();
			this.columnHeader_ReplyCount = new System.Windows.Forms.ColumnHeader();
			this.columnHeader_LastReply = new System.Windows.Forms.ColumnHeader();
			this.imageList_TopicList = new System.Windows.Forms.ImageList(this.components);
			this.toolBar_List = new System.Windows.Forms.ToolBar();
			this.toolBarButton_First = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Previous = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_1 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Go = new System.Windows.Forms.ToolBarButton();
			this.contextMenu_Page = new System.Windows.Forms.ContextMenu();
			this.toolBarButton_Separator_2 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Next = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Last = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_3 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Refresh_List = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_4 = new System.Windows.Forms.ToolBarButton();
			this.imageList_ToolBar_List = new System.Windows.Forms.ImageList(this.components);
			this.panel_Search = new System.Windows.Forms.Panel();
			this.label_PageInfo = new System.Windows.Forms.Label();
			this.label_SectionTitle = new System.Windows.Forms.Label();
			this.button_Find = new System.Windows.Forms.Button();
			this.label_Search = new System.Windows.Forms.Label();
			this.textBox_Search = new System.Windows.Forms.TextBox();
			this.splitter_H = new System.Windows.Forms.Splitter();
			this.imageList_ToolBar_Content = new System.Windows.Forms.ImageList(this.components);
			this.imageList_TabPage = new System.Windows.Forms.ImageList(this.components);
			this.panel_Title = new System.Windows.Forms.Panel();
			this.label_Title = new System.Windows.Forms.Label();
			this.toolBar_Content = new System.Windows.Forms.ToolBar();
			this.toolBarButton_Separator_5 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_New = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Reply = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_6 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Open = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Refresh_Content = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_7 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Browser = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_8 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_FullScreen = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Separator_9 = new System.Windows.Forms.ToolBarButton();
			this.toolBarButton_Close = new System.Windows.Forms.ToolBarButton();
			this.tabControl_Content = new System.Windows.Forms.TabControl();
			this.statusBarPanel_Process = new System.Windows.Forms.StatusBarPanel();
			this.statusBarPanel_Position = new System.Windows.Forms.StatusBarPanel();
			this.panel_Guide.SuspendLayout();
			this.tabControl_Guide.SuspendLayout();
			this.tabPage_Online.SuspendLayout();
			this.groupBox_sType.SuspendLayout();
			this.tabPage_Offline.SuspendLayout();
			this.groupBox_Reload.SuspendLayout();
			this.panel_List.SuspendLayout();
			this.panel_Search.SuspendLayout();
			this.panel_Title.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel_Process)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel_Position)).BeginInit();
			this.SuspendLayout();
			// 
			// statusBar
			// 
			this.statusBar.Location = new System.Drawing.Point(0, 511);
			this.statusBar.Name = "statusBar";
			this.statusBar.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						 this.statusBarPanel_Process,
																						 this.statusBarPanel_Position});
			this.statusBar.ShowPanels = true;
			this.statusBar.Size = new System.Drawing.Size(792, 22);
			this.statusBar.TabIndex = 0;
			// 
			// mainMenu_Default
			// 
			this.mainMenu_Default.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							 this.menuItem_File,
																							 this.menuItem_Tool,
																							 this.menuItem_Help});
			// 
			// menuItem_File
			// 
			this.menuItem_File.Index = 0;
			this.menuItem_File.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuItem_Exit});
			this.menuItem_File.Text = "ļ(&F)";
			// 
			// menuItem_Exit
			// 
			this.menuItem_Exit.Index = 0;
			this.menuItem_Exit.Text = "˳(&X)";
			this.menuItem_Exit.Click += new System.EventHandler(this.menuItem_Exit_Click);
			// 
			// menuItem_Tool
			// 
			this.menuItem_Tool.Index = 1;
			this.menuItem_Tool.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuItem_Update_Section,
																						  this.menuItem_Software_Upgrade,
																						  this.menuItem1,
																						  this.menuItem_Option});
			this.menuItem_Tool.Text = "(&T)";
			// 
			// menuItem_Update_Section
			// 
			this.menuItem_Update_Section.Index = 0;
			this.menuItem_Update_Section.Text = "̳(&U)";
			this.menuItem_Update_Section.Click += new System.EventHandler(this.menuItem_Update_Section_Click);
			// 
			// menuItem_Software_Upgrade
			// 
			this.menuItem_Software_Upgrade.Index = 1;
			this.menuItem_Software_Upgrade.Text = "(&S)";
			this.menuItem_Software_Upgrade.Click += new System.EventHandler(this.menuItem_Software_Upgrade_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "-";
			// 
			// menuItem_Option
			// 
			this.menuItem_Option.Index = 3;
			this.menuItem_Option.Text = "ѡ(&O)...";
			this.menuItem_Option.Click += new System.EventHandler(this.menuItem_Option_Click);
			// 
			// menuItem_Help
			// 
			this.menuItem_Help.Index = 2;
			this.menuItem_Help.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuItem_Website,
																						  this.menuItem_Bug,
																						  this.menuItem2,
																						  this.menuItem_About});
			this.menuItem_Help.Text = "(&H)";
			// 
			// menuItem_Website
			// 
			this.menuItem_Website.Index = 0;
			this.menuItem_Website.Text = "վ(&W)...";
			this.menuItem_Website.Click += new System.EventHandler(this.menuItem_Website_Click);
			// 
			// menuItem_Bug
			// 
			this.menuItem_Bug.Index = 1;
			this.menuItem_Bug.Text = "Bug(&R)";
			this.menuItem_Bug.Click += new System.EventHandler(this.menuItem_Bug_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.Text = "-";
			// 
			// menuItem_About
			// 
			this.menuItem_About.Index = 3;
			this.menuItem_About.Shortcut = System.Windows.Forms.Shortcut.F1;
			this.menuItem_About.Text = "(&A)...";
			this.menuItem_About.Click += new System.EventHandler(this.menuItem_About_Click);
			// 
			// panel_Guide
			// 
			this.panel_Guide.Controls.Add(this.tabControl_Guide);
			this.panel_Guide.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel_Guide.Location = new System.Drawing.Point(0, 0);
			this.panel_Guide.Name = "panel_Guide";
			this.panel_Guide.Size = new System.Drawing.Size(176, 511);
			this.panel_Guide.TabIndex = 9;
			// 
			// tabControl_Guide
			// 
			this.tabControl_Guide.Controls.Add(this.tabPage_Online);
			this.tabControl_Guide.Controls.Add(this.tabPage_Offline);
			this.tabControl_Guide.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl_Guide.ItemSize = new System.Drawing.Size(60, 17);
			this.tabControl_Guide.Location = new System.Drawing.Point(0, 0);
			this.tabControl_Guide.Name = "tabControl_Guide";
			this.tabControl_Guide.SelectedIndex = 0;
			this.tabControl_Guide.Size = new System.Drawing.Size(176, 511);
			this.tabControl_Guide.TabIndex = 3;
			this.tabControl_Guide.Tag = "";
			this.tabControl_Guide.SelectedIndexChanged += new System.EventHandler(this.tabControl_Guide_SelectedIndexChanged);
			// 
			// tabPage_Online
			// 
			this.tabPage_Online.AutoScroll = true;
			this.tabPage_Online.Controls.Add(this.groupBox_sType);
			this.tabPage_Online.Controls.Add(this.treeView_Online);
			this.tabPage_Online.Location = new System.Drawing.Point(4, 21);
			this.tabPage_Online.Name = "tabPage_Online";
			this.tabPage_Online.Size = new System.Drawing.Size(168, 486);
			this.tabPage_Online.TabIndex = 0;
			this.tabPage_Online.Tag = "Online";
			this.tabPage_Online.Text = "̳";
			// 
			// groupBox_sType
			// 
			this.groupBox_sType.Controls.Add(this.radioButton_sExcerption);
			this.groupBox_sType.Controls.Add(this.radioButton_sNormal);
			this.groupBox_sType.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.groupBox_sType.Location = new System.Drawing.Point(0, 422);
			this.groupBox_sType.Name = "groupBox_sType";
			this.groupBox_sType.RightToLeft = System.Windows.Forms.RightToLeft.No;
			this.groupBox_sType.Size = new System.Drawing.Size(168, 64);
			this.groupBox_sType.TabIndex = 1;
			this.groupBox_sType.TabStop = false;
			this.groupBox_sType.Text = "ѡ";
			// 
			// radioButton_sExcerption
			// 
			this.radioButton_sExcerption.Location = new System.Drawing.Point(96, 24);
			this.radioButton_sExcerption.Name = "radioButton_sExcerption";
			this.radioButton_sExcerption.Size = new System.Drawing.Size(64, 24);
			this.radioButton_sExcerption.TabIndex = 1;
			this.radioButton_sExcerption.Text = "ժ";
			this.radioButton_sExcerption.CheckedChanged += new System.EventHandler(this.radioButton_sExcerption_CheckedChanged);
			// 
			// radioButton_sNormal
			// 
			this.radioButton_sNormal.Checked = true;
			this.radioButton_sNormal.Location = new System.Drawing.Point(24, 24);
			this.radioButton_sNormal.Name = "radioButton_sNormal";
			this.radioButton_sNormal.Size = new System.Drawing.Size(64, 24);
			this.radioButton_sNormal.TabIndex = 0;
			this.radioButton_sNormal.TabStop = true;
			this.radioButton_sNormal.Text = "";
			this.radioButton_sNormal.CheckedChanged += new System.EventHandler(this.radioButton_sNormal_CheckedChanged);
			// 
			// treeView_Online
			// 
			this.treeView_Online.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeView_Online.ImageList = this.imageList_TreeView;
			this.treeView_Online.ItemHeight = 16;
			this.treeView_Online.Location = new System.Drawing.Point(0, 0);
			this.treeView_Online.Name = "treeView_Online";
			this.treeView_Online.Size = new System.Drawing.Size(168, 486);
			this.treeView_Online.TabIndex = 0;
			this.treeView_Online.AfterExpand += new System.Windows.Forms.TreeViewEventHandler(this.treeView_Online_AfterExpand);
			this.treeView_Online.AfterCollapse += new System.Windows.Forms.TreeViewEventHandler(this.treeView_Online_AfterCollapse);
			this.treeView_Online.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView_Online_AfterSelect);
			// 
			// imageList_TreeView
			// 
			this.imageList_TreeView.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList_TreeView.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_TreeView.ImageStream")));
			this.imageList_TreeView.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// tabPage_Offline
			// 
			this.tabPage_Offline.Controls.Add(this.groupBox_Reload);
			this.tabPage_Offline.Controls.Add(this.treeView_Offline);
			this.tabPage_Offline.Location = new System.Drawing.Point(4, 21);
			this.tabPage_Offline.Name = "tabPage_Offline";
			this.tabPage_Offline.Size = new System.Drawing.Size(168, 486);
			this.tabPage_Offline.TabIndex = 1;
			this.tabPage_Offline.Tag = "Offline";
			this.tabPage_Offline.Text = "";
			this.tabPage_Offline.Visible = false;
			// 
			// groupBox_Reload
			// 
			this.groupBox_Reload.Controls.Add(this.button_Reload);
			this.groupBox_Reload.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.groupBox_Reload.Location = new System.Drawing.Point(0, 438);
			this.groupBox_Reload.Name = "groupBox_Reload";
			this.groupBox_Reload.Size = new System.Drawing.Size(168, 48);
			this.groupBox_Reload.TabIndex = 1;
			this.groupBox_Reload.TabStop = false;
			// 
			// button_Reload
			// 
			this.button_Reload.Location = new System.Drawing.Point(48, 16);
			this.button_Reload.Name = "button_Reload";
			this.button_Reload.TabIndex = 0;
			this.button_Reload.Text = "";
			this.button_Reload.Click += new System.EventHandler(this.button_Reload_Click);
			// 
			// treeView_Offline
			// 
			this.treeView_Offline.Dock = System.Windows.Forms.DockStyle.Fill;
			this.treeView_Offline.ImageList = this.imageList_TreeView;
			this.treeView_Offline.ItemHeight = 16;
			this.treeView_Offline.Location = new System.Drawing.Point(0, 0);
			this.treeView_Offline.Name = "treeView_Offline";
			this.treeView_Offline.Size = new System.Drawing.Size(168, 486);
			this.treeView_Offline.TabIndex = 0;
			this.treeView_Offline.AfterExpand += new System.Windows.Forms.TreeViewEventHandler(this.treeView_Offline_AfterExpand);
			this.treeView_Offline.AfterCollapse += new System.Windows.Forms.TreeViewEventHandler(this.treeView_Offline_AfterCollapse);
			this.treeView_Offline.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView_Offline_AfterSelect);
			// 
			// splitter_V
			// 
			this.splitter_V.Location = new System.Drawing.Point(176, 0);
			this.splitter_V.Name = "splitter_V";
			this.splitter_V.Size = new System.Drawing.Size(5, 511);
			this.splitter_V.TabIndex = 10;
			this.splitter_V.TabStop = false;
			this.splitter_V.DoubleClick += new System.EventHandler(this.splitter_V_DoubleClick);
			// 
			// panel_List
			// 
			this.panel_List.Controls.Add(this.listView_List);
			this.panel_List.Controls.Add(this.toolBar_List);
			this.panel_List.Controls.Add(this.panel_Search);
			this.panel_List.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel_List.Location = new System.Drawing.Point(181, 0);
			this.panel_List.Name = "panel_List";
			this.panel_List.Size = new System.Drawing.Size(611, 200);
			this.panel_List.TabIndex = 11;
			// 
			// listView_List
			// 
			this.listView_List.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																							this.columnHeader_ID,
																							this.columnHeader_Title,
																							this.columnHeader_Nickname,
																							this.columnHeader_ViewCount,
																							this.columnHeader_ReplyCount,
																							this.columnHeader_LastReply});
			this.listView_List.Dock = System.Windows.Forms.DockStyle.Fill;
			this.listView_List.FullRowSelect = true;
			this.listView_List.HideSelection = false;
			this.listView_List.Location = new System.Drawing.Point(0, 52);
			this.listView_List.Name = "listView_List";
			this.listView_List.Size = new System.Drawing.Size(611, 148);
			this.listView_List.SmallImageList = this.imageList_TopicList;
			this.listView_List.TabIndex = 3;
			this.listView_List.View = System.Windows.Forms.View.Details;
			this.listView_List.Click += new System.EventHandler(this.listView_List_Click);
			this.listView_List.ColumnClick += new System.Windows.Forms.ColumnClickEventHandler(this.listView_List_ColumnClick);
			// 
			// columnHeader_ID
			// 
			this.columnHeader_ID.Text = "";
			// 
			// columnHeader_Title
			// 
			this.columnHeader_Title.Text = "";
			this.columnHeader_Title.Width = 220;
			// 
			// columnHeader_Nickname
			// 
			this.columnHeader_Nickname.Text = "";
			this.columnHeader_Nickname.Width = 100;
			// 
			// columnHeader_ViewCount
			// 
			this.columnHeader_ViewCount.Text = "";
			this.columnHeader_ViewCount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.columnHeader_ViewCount.Width = 40;
			// 
			// columnHeader_ReplyCount
			// 
			this.columnHeader_ReplyCount.Text = "ظ";
			this.columnHeader_ReplyCount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.columnHeader_ReplyCount.Width = 40;
			// 
			// columnHeader_LastReply
			// 
			this.columnHeader_LastReply.Text = "ظ";
			this.columnHeader_LastReply.Width = 130;
			// 
			// imageList_TopicList
			// 
			this.imageList_TopicList.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList_TopicList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_TopicList.ImageStream")));
			this.imageList_TopicList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// toolBar_List
			// 
			this.toolBar_List.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar_List.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							this.toolBarButton_First,
																							this.toolBarButton_Previous,
																							this.toolBarButton_Separator_1,
																							this.toolBarButton_Go,
																							this.toolBarButton_Separator_2,
																							this.toolBarButton_Next,
																							this.toolBarButton_Last,
																							this.toolBarButton_Separator_3,
																							this.toolBarButton_Refresh_List,
																							this.toolBarButton_Separator_4});
			this.toolBar_List.ButtonSize = new System.Drawing.Size(23, 22);
			this.toolBar_List.DropDownArrows = true;
			this.toolBar_List.ImageList = this.imageList_ToolBar_List;
			this.toolBar_List.Location = new System.Drawing.Point(0, 24);
			this.toolBar_List.Name = "toolBar_List";
			this.toolBar_List.ShowToolTips = true;
			this.toolBar_List.Size = new System.Drawing.Size(611, 28);
			this.toolBar_List.TabIndex = 2;
			this.toolBar_List.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_List_ButtonClick);
			// 
			// toolBarButton_First
			// 
			this.toolBarButton_First.ImageIndex = 0;
			this.toolBarButton_First.Tag = "First";
			this.toolBarButton_First.ToolTipText = "һҳ";
			// 
			// toolBarButton_Previous
			// 
			this.toolBarButton_Previous.ImageIndex = 2;
			this.toolBarButton_Previous.Tag = "Previous";
			this.toolBarButton_Previous.ToolTipText = "һҳ";
			// 
			// toolBarButton_Separator_1
			// 
			this.toolBarButton_Separator_1.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_Go
			// 
			this.toolBarButton_Go.DropDownMenu = this.contextMenu_Page;
			this.toolBarButton_Go.ImageIndex = 4;
			this.toolBarButton_Go.Style = System.Windows.Forms.ToolBarButtonStyle.DropDownButton;
			this.toolBarButton_Go.Tag = "Go";
			this.toolBarButton_Go.ToolTipText = "ת";
			// 
			// toolBarButton_Separator_2
			// 
			this.toolBarButton_Separator_2.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_Next
			// 
			this.toolBarButton_Next.ImageIndex = 3;
			this.toolBarButton_Next.Tag = "Next";
			this.toolBarButton_Next.ToolTipText = "һҳ";
			// 
			// toolBarButton_Last
			// 
			this.toolBarButton_Last.ImageIndex = 1;
			this.toolBarButton_Last.Tag = "Last";
			this.toolBarButton_Last.ToolTipText = "βҳ";
			// 
			// toolBarButton_Separator_3
			// 
			this.toolBarButton_Separator_3.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_Refresh_List
			// 
			this.toolBarButton_Refresh_List.ImageIndex = 5;
			this.toolBarButton_Refresh_List.Tag = "Refresh";
			this.toolBarButton_Refresh_List.ToolTipText = "ˢ";
			// 
			// toolBarButton_Separator_4
			// 
			this.toolBarButton_Separator_4.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// imageList_ToolBar_List
			// 
			this.imageList_ToolBar_List.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList_ToolBar_List.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_ToolBar_List.ImageStream")));
			this.imageList_ToolBar_List.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// panel_Search
			// 
			this.panel_Search.BackColor = System.Drawing.SystemColors.InactiveCaption;
			this.panel_Search.Controls.Add(this.label_PageInfo);
			this.panel_Search.Controls.Add(this.label_SectionTitle);
			this.panel_Search.Controls.Add(this.button_Find);
			this.panel_Search.Controls.Add(this.label_Search);
			this.panel_Search.Controls.Add(this.textBox_Search);
			this.panel_Search.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel_Search.ForeColor = System.Drawing.SystemColors.ControlLightLight;
			this.panel_Search.Location = new System.Drawing.Point(0, 0);
			this.panel_Search.Name = "panel_Search";
			this.panel_Search.Size = new System.Drawing.Size(611, 24);
			this.panel_Search.TabIndex = 0;
			// 
			// label_PageInfo
			// 
			this.label_PageInfo.Location = new System.Drawing.Point(104, 0);
			this.label_PageInfo.Name = "label_PageInfo";
			this.label_PageInfo.TabIndex = 4;
			this.label_PageInfo.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// label_SectionTitle
			// 
			this.label_SectionTitle.Font = new System.Drawing.Font("", 10.5F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(134)));
			this.label_SectionTitle.Location = new System.Drawing.Point(16, 0);
			this.label_SectionTitle.Name = "label_SectionTitle";
			this.label_SectionTitle.Size = new System.Drawing.Size(80, 23);
			this.label_SectionTitle.TabIndex = 3;
			this.label_SectionTitle.TextAlign = System.Drawing.ContentAlignment.BottomLeft;
			// 
			// button_Find
			// 
			this.button_Find.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button_Find.BackColor = System.Drawing.SystemColors.Control;
			this.button_Find.Image = ((System.Drawing.Image)(resources.GetObject("button_Find.Image")));
			this.button_Find.Location = new System.Drawing.Point(566, 0);
			this.button_Find.Name = "button_Find";
			this.button_Find.Size = new System.Drawing.Size(28, 23);
			this.button_Find.TabIndex = 2;
			this.button_Find.Click += new System.EventHandler(this.button_Find_Click);
			// 
			// label_Search
			// 
			this.label_Search.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.label_Search.BackColor = System.Drawing.SystemColors.InactiveCaption;
			this.label_Search.Location = new System.Drawing.Point(390, 0);
			this.label_Search.Name = "label_Search";
			this.label_Search.Size = new System.Drawing.Size(32, 24);
			this.label_Search.TabIndex = 1;
			this.label_Search.Text = "";
			this.label_Search.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// textBox_Search
			// 
			this.textBox_Search.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.textBox_Search.Location = new System.Drawing.Point(430, 0);
			this.textBox_Search.Name = "textBox_Search";
			this.textBox_Search.Size = new System.Drawing.Size(128, 21);
			this.textBox_Search.TabIndex = 0;
			this.textBox_Search.Text = "";
			this.textBox_Search.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.textBox_Search_KeyPress);
			// 
			// splitter_H
			// 
			this.splitter_H.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter_H.Location = new System.Drawing.Point(181, 200);
			this.splitter_H.Name = "splitter_H";
			this.splitter_H.Size = new System.Drawing.Size(611, 3);
			this.splitter_H.TabIndex = 12;
			this.splitter_H.TabStop = false;
			// 
			// imageList_ToolBar_Content
			// 
			this.imageList_ToolBar_Content.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList_ToolBar_Content.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_ToolBar_Content.ImageStream")));
			this.imageList_ToolBar_Content.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// imageList_TabPage
			// 
			this.imageList_TabPage.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList_TabPage.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList_TabPage.ImageStream")));
			this.imageList_TabPage.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// panel_Title
			// 
			this.panel_Title.Controls.Add(this.label_Title);
			this.panel_Title.Controls.Add(this.toolBar_Content);
			this.panel_Title.Dock = System.Windows.Forms.DockStyle.Top;
			this.panel_Title.Location = new System.Drawing.Point(181, 203);
			this.panel_Title.Name = "panel_Title";
			this.panel_Title.Size = new System.Drawing.Size(611, 29);
			this.panel_Title.TabIndex = 15;
			// 
			// label_Title
			// 
			this.label_Title.Location = new System.Drawing.Point(8, 8);
			this.label_Title.Name = "label_Title";
			this.label_Title.Size = new System.Drawing.Size(368, 23);
			this.label_Title.TabIndex = 16;
			// 
			// toolBar_Content
			// 
			this.toolBar_Content.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.toolBar_Content.Appearance = System.Windows.Forms.ToolBarAppearance.Flat;
			this.toolBar_Content.Buttons.AddRange(new System.Windows.Forms.ToolBarButton[] {
																							   this.toolBarButton_Separator_5,
																							   this.toolBarButton_New,
																							   this.toolBarButton_Reply,
																							   this.toolBarButton_Separator_6,
																							   this.toolBarButton_Open,
																							   this.toolBarButton_Refresh_Content,
																							   this.toolBarButton_Separator_7,
																							   this.toolBarButton_Browser,
																							   this.toolBarButton_Separator_8,
																							   this.toolBarButton_FullScreen,
																							   this.toolBarButton_Separator_9,
																							   this.toolBarButton_Close});
			this.toolBar_Content.ButtonSize = new System.Drawing.Size(43, 22);
			this.toolBar_Content.Dock = System.Windows.Forms.DockStyle.None;
			this.toolBar_Content.DropDownArrows = true;
			this.toolBar_Content.ImageList = this.imageList_ToolBar_Content;
			this.toolBar_Content.Location = new System.Drawing.Point(408, 0);
			this.toolBar_Content.Name = "toolBar_Content";
			this.toolBar_Content.ShowToolTips = true;
			this.toolBar_Content.Size = new System.Drawing.Size(208, 28);
			this.toolBar_Content.TabIndex = 15;
			this.toolBar_Content.ButtonClick += new System.Windows.Forms.ToolBarButtonClickEventHandler(this.toolBar_Content_ButtonClick);
			// 
			// toolBarButton_Separator_5
			// 
			this.toolBarButton_Separator_5.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_New
			// 
			this.toolBarButton_New.ImageIndex = 0;
			this.toolBarButton_New.Tag = "New";
			this.toolBarButton_New.ToolTipText = "";
			// 
			// toolBarButton_Reply
			// 
			this.toolBarButton_Reply.ImageIndex = 1;
			this.toolBarButton_Reply.Tag = "Reply";
			this.toolBarButton_Reply.ToolTipText = "";
			// 
			// toolBarButton_Separator_6
			// 
			this.toolBarButton_Separator_6.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_Open
			// 
			this.toolBarButton_Open.ImageIndex = 2;
			this.toolBarButton_Open.Tag = "Open";
			this.toolBarButton_Open.ToolTipText = "";
			// 
			// toolBarButton_Refresh_Content
			// 
			this.toolBarButton_Refresh_Content.ImageIndex = 3;
			this.toolBarButton_Refresh_Content.Tag = "Refresh";
			this.toolBarButton_Refresh_Content.ToolTipText = "ˢ";
			// 
			// toolBarButton_Separator_7
			// 
			this.toolBarButton_Separator_7.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_Browser
			// 
			this.toolBarButton_Browser.ImageIndex = 4;
			this.toolBarButton_Browser.Tag = "Browser";
			this.toolBarButton_Browser.ToolTipText = "";
			// 
			// toolBarButton_Separator_8
			// 
			this.toolBarButton_Separator_8.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_FullScreen
			// 
			this.toolBarButton_FullScreen.ImageIndex = 5;
			this.toolBarButton_FullScreen.Style = System.Windows.Forms.ToolBarButtonStyle.ToggleButton;
			this.toolBarButton_FullScreen.Tag = "FullScreen";
			this.toolBarButton_FullScreen.ToolTipText = "ȫ";
			// 
			// toolBarButton_Separator_9
			// 
			this.toolBarButton_Separator_9.Style = System.Windows.Forms.ToolBarButtonStyle.Separator;
			// 
			// toolBarButton_Close
			// 
			this.toolBarButton_Close.ImageIndex = 6;
			this.toolBarButton_Close.Tag = "Close";
			this.toolBarButton_Close.ToolTipText = "ر";
			// 
			// tabControl_Content
			// 
			this.tabControl_Content.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabControl_Content.ImageList = this.imageList_TabPage;
			this.tabControl_Content.ItemSize = new System.Drawing.Size(0, 19);
			this.tabControl_Content.Location = new System.Drawing.Point(181, 232);
			this.tabControl_Content.Multiline = true;
			this.tabControl_Content.Name = "tabControl_Content";
			this.tabControl_Content.SelectedIndex = 0;
			this.tabControl_Content.Size = new System.Drawing.Size(611, 279);
			this.tabControl_Content.TabIndex = 16;
			this.tabControl_Content.SelectedIndexChanged += new System.EventHandler(this.tabControl_Content_SelectedIndexChanged);
			// 
			// statusBarPanel_Process
			// 
			this.statusBarPanel_Process.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel_Process.Text = "";
			this.statusBarPanel_Process.Width = 676;
			// 
			// statusBarPanel_Position
			// 
			this.statusBarPanel_Position.Text = "";
			// 
			// Form_Main
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(792, 533);
			this.Controls.Add(this.tabControl_Content);
			this.Controls.Add(this.panel_Title);
			this.Controls.Add(this.splitter_H);
			this.Controls.Add(this.panel_List);
			this.Controls.Add(this.splitter_V);
			this.Controls.Add(this.panel_Guide);
			this.Controls.Add(this.statusBar);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu_Default;
			this.Name = "Form_Main";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "̳";
			this.Load += new System.EventHandler(this.Form_Main_Load);
			this.panel_Guide.ResumeLayout(false);
			this.tabControl_Guide.ResumeLayout(false);
			this.tabPage_Online.ResumeLayout(false);
			this.groupBox_sType.ResumeLayout(false);
			this.tabPage_Offline.ResumeLayout(false);
			this.groupBox_Reload.ResumeLayout(false);
			this.panel_List.ResumeLayout(false);
			this.panel_Search.ResumeLayout(false);
			this.panel_Title.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel_Process)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel_Position)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private int Load_TreeView_Online(string xmlFilename)
		{
			try
			{
				this.treeView_Online.Nodes.Clear();
				XML_DataSet section = new XML_DataSet (xmlFilename);
				DataTable classtable = section.dataset.Tables["Class"];
				foreach(DataRow classrow in classtable.Rows)
				{
					TreeNode classnode = new TreeNode
						(classrow["ClassTitle"].ToString());
					foreach(DataRow sectionrow in classrow.GetChildRows(classtable.ChildRelations["Class_Section"]))
					{
						TreeNode sectionnode = new TreeNode
							(sectionrow["SectionTitle"].ToString());
						sectionnode.Tag = "S" + sectionrow["SectionID"].ToString();
						sectionnode.ImageIndex = 2;
						sectionnode.SelectedImageIndex = 3;
						classnode.Nodes.Add(sectionnode);
					}
					classnode.Tag = "C" + classrow["ClassID"].ToString();
					this.treeView_Online.Nodes.Add(classnode);
				}
				this.treeView_Online.Refresh();
			}
			catch
			{
				MessageBox.Show("̳ݴ£","",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return -1;
			}
			return 0;
		}


		private int Load_TreeView_Offline(string xmlFilename)
		{
			try
			{
				this.treeView_Offline.Nodes.Clear();
				XML_DataSet section = new XML_DataSet (xmlFilename);
				DataTable classtable = section.dataset.Tables["Class"];
				foreach(DataRow classrow in classtable.Rows)
				{
					TreeNode classnode = new TreeNode
						(classrow["ClassTitle"].ToString());
					foreach(DataRow sectionrow in classrow.GetChildRows(classtable.ChildRelations["Class_Section"]))
					{
						TreeNode sectionnode = new TreeNode
							(sectionrow["SectionTitle"].ToString());
						sectionnode.Tag = "S" + sectionrow["SectionID"].ToString();
						sectionnode.ImageIndex = 2;
						sectionnode.SelectedImageIndex = 3;
						classnode.Nodes.Add(sectionnode);
					}
					classnode.Tag = "C" + classrow["ClassID"].ToString();
					this.treeView_Offline.Nodes.Add(classnode);
				}
				this.treeView_Offline.Refresh();
			}
			catch
			{
				MessageBox.Show("̳ݴ£","",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return -1;
			}
			return 0;
		}

		private int Load_TopicList(string xmlFilename)
		{
			try
			{
				this.listView_List.Items.Clear();
				XML_DataSet section = new XML_DataSet (xmlFilename);
				DataTable articletable = section.dataset.Tables["Article"];
				bool ColorIndex = false;
				foreach(DataRow articlerow in articletable.Rows)
				{
					ListViewItem articleitem = new ListViewItem();
					articleitem.Tag = articlerow["ID"].ToString();
					articleitem.Text = articlerow["ID"].ToString();
					articleitem.ImageIndex = 
						(this.article_list.getview()=="ex"?1:0);
					ColorIndex = (!ColorIndex);
					articleitem.BackColor = 
						(ColorIndex?Color.White:Color.FromArgb(100,240,240,240));
					articleitem.SubItems.Add(articlerow["Title"].ToString());
					articleitem.SubItems.Add(articlerow["User"].ToString());
					articleitem.SubItems.Add(articlerow["VC"].ToString());
					articleitem.SubItems.Add(articlerow["RC"].ToString());
					articleitem.SubItems.Add(articlerow["LR_DT"].ToString());
					this.listView_List.Items.Add(articleitem);
				}
				this.listView_List.Refresh();
			}
			catch
			{
				return -1;
			}
			return 0;
		}

		private int Load_ToolBar_List(string xmlFilename)
		{
			try
			{
				if (article_list.getpage() > 1)
				{
					this.toolBarButton_First.Enabled = true;
					this.toolBarButton_Previous.Enabled = true;
				}
				else
				{
					this.toolBarButton_First.Enabled = false;
					this.toolBarButton_Previous.Enabled = false;
				}
				if (article_list.getpage() < article_list.getpagecount())
				{
					this.toolBarButton_Last.Enabled = true;
					this.toolBarButton_Next.Enabled = true;
				}
				else
				{
					this.toolBarButton_Last.Enabled = false;
					this.toolBarButton_Next.Enabled = false;
				}
				this.contextMenu_Page.MenuItems.Clear();
				for (int i=1;i<=article_list.getpagecount();i++)
				{
					MenuItem menuitem = new MenuItem(i.ToString());
					menuitem.Click+=new EventHandler(contextMenu_Page_Click);
					menuitem.Checked = (i==this.article_list.getpage());
					this.contextMenu_Page.MenuItems.Add(menuitem);
				}
			}
			catch
			{
				MessageBox.Show("Error! [LTL]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return -1;
			}
			return 0;
		}

		private int Load_Panel_Search(string xmlFilename)
		{
			try
			{
				if (this.article_list.getSID() !=0 )
				{
					this.label_SectionTitle.Text = this.article_list.getstitle();
					this.label_PageInfo.Text =
						"" + this.article_list.getpage().ToString() + "ҳ  "
						+ this.article_list.getpagecount().ToString() + "ҳ";
				}
				else
				{
					this.label_SectionTitle.Text = "ѡ";
					this.label_PageInfo.Text = "";
				}
			}
			catch
			{
				MessageBox.Show("Error! [LPS]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return -1;
			}
			return 0;
		}

		private void contextMenu_Page_Click(object sender, System.EventArgs e)
		{
			this.article_list.setpage(Convert.ToInt16(((MenuItem)(sender)).Text));
			Load_Panel_List(this.list_filename);
		}

		private int Load_Panel_List(string xmlFilename)
		{
			Load_Panel_Search(xmlFilename);
			Load_TopicList(xmlFilename);
			Load_ToolBar_List(xmlFilename);
			return 0;
		}

		private void menuItem_Exit_Click(object sender, System.EventArgs e)
		{
			//this.Close();
			Application.Exit();
		}

		private void menuItem_Update_Section_Click(object sender, System.EventArgs e)
		{
			string section_url = "http://" + GV.hostname + "/viewer/show_section.php";
			DL_Data dl = new DL_Data(section_url,section_filename);
			this.statusBarPanel_Process.Text = "УԺ...";
			dl.ShowDialog();
			if (dl.isComplete())
			{
				Load_TreeView_Online(this.section_filename);
				Load_TreeView_Offline(this.section_filename);
			}
			this.statusBarPanel_Process.Text = "";
		}

		private void treeView_Online_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			switch (e.Node.Tag.ToString().Substring(0,1))
			{
				case "S":
					article_list.setSID(Convert.ToInt16(e.Node.Tag.ToString().Substring(1)));
					if (article_list.isCorrect())
					{
						Load_Panel_List(this.list_filename);
					}
					break;
			}
		}

		private void treeView_Offline_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			switch (e.Node.Tag.ToString().Substring(0,1))
			{
				case "S":
					Load_Excerption();
					break;
			}
		}

		private void toolBar_List_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			switch(e.Button.Tag.ToString())
			{
				case "First":
					this.article_list.setpage(1);
					break;
				case "Previous":
					this.article_list.setpage(this.article_list.getpage()-1);
					break;
				case "Next":
					this.article_list.setpage(this.article_list.getpage()+1);
					break;
				case "Last":
					this.article_list.setpage(this.article_list.getpagecount());
					break;
				case "Refresh":
					this.article_list.Get_Data();
					break;
				default:
					return;
			}
			Load_Panel_List(this.list_filename);
		}

		private void radioButton_sNormal_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.radioButton_sNormal.Checked)
			{
				this.article_list.setview("normal");
				this.statusBarPanel_Position.Text = "";
				Load_Panel_List(this.list_filename);
			}
		}

		private void radioButton_sExcerption_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.radioButton_sExcerption.Checked)
			{
				this.article_list.setview("ex");
				this.statusBarPanel_Position.Text = "ժ";
				Load_Panel_List(this.list_filename);
			}
		}

		private void treeView_Online_AfterExpand(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			e.Node.ImageIndex = e.Node.SelectedImageIndex = 1;
		}

		private void treeView_Online_AfterCollapse(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			e.Node.ImageIndex = e.Node.SelectedImageIndex = 0;
		}

		private void treeView_Offline_AfterExpand(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			e.Node.ImageIndex = e.Node.SelectedImageIndex = 1;
		}

		private void treeView_Offline_AfterCollapse(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			e.Node.ImageIndex = e.Node.SelectedImageIndex = 0;
		}

		private void button_Find_Click(object sender, System.EventArgs e)
		{
			this.article_list.setsearch(this.textBox_Search.Text);
			Load_Panel_List(this.list_filename);
		}

		private void textBox_Search_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == 13)
			{
				this.button_Find.PerformClick();
			}
		}

		private void listView_List_ColumnClick(object sender, System.Windows.Forms.ColumnClickEventArgs e)
		{
			switch(e.Column)
			{
				case 0:
				case 1:
					this.article_list.setsort("topic");
					break;
				case 3:
				case 4:
					this.article_list.setsort("hot");
					break;
				case 5:
					this.article_list.setsort("reply");
					break;
				default:
					return;
			}
			Load_Panel_List(this.list_filename);
		}

		private void listView_List_Click(object sender, System.EventArgs e)
		{
			foreach(ListViewItem listitem in
				((ListView)(sender)).SelectedItems)
			{
				Add_Content_Page(listitem.Text);
			}
		}

		private void Add_Content_Page(string aid)
		{
			TabPage tabpage = new TabPage();
			bool ex;

			switch(this.article_list.getview())
			{
				case "normal":
					ex = false;
					tabpage.Tag = "N" + aid;
					tabpage.ImageIndex = 0;
					break;
				case "ex":
					ex = true;
					tabpage.Tag = "E" + aid;
					tabpage.ImageIndex = 1;
					break;
				default:
					ex = false;
					tabpage.Tag = "N" + aid;
					tabpage.ImageIndex = 0;
					break;
			}
			
			if (aid == "0") // Add Empty Page
			{
				tabpage.Tag = "EMPTY";
			}

			foreach(System.Windows.Forms.TabPage tp in this.tabControl_Content.TabPages)
			{
				if (tp.Tag.ToString() == tabpage.Tag.ToString())
				{
					this.tabControl_Content.SelectedTab = tp;
					return;
				}
			}

			if (aid == "0")
			{
				this.label_Title.Text = tabpage.Text = "û";
			}
			else
			{
				Article_Content article = new Article_Content();
				article.setaid(aid);
				article.setex(ex);
				article.Get_Data();
				if (!article.isCorrect())
				{
					return;
				}
				this.label_Title.Text = tabpage.Text = article.gettitle();
			}

			this.tabControl_Content.TabPages.Add(tabpage);
			this.tabControl_Content.SelectedTab = tabpage;

			if (aid != "0" && this.tabControl_Content.TabCount > 1)
			{
				foreach(TabPage tp in this.tabControl_Content.TabPages)
				{
					if (tp.Tag.ToString() == "EMPTY") //Remove Empty Page
					{
						this.tabControl_Content.TabPages.Remove(tp);
					}
				}
			}

			try
			{
				AxSHDocVw.AxWebBrowser wb = new AxSHDocVw.AxWebBrowser();
				tabpage.Controls.AddRange(new Control[] {wb});
				wb.ContainingControl = this;
				wb.Dock = DockStyle.Fill;
				wb.Tag = "WebBrowser";

				object vFlags = null;
				object vTarget = null;
				object vPost = null;
				object vHeader = null;
				string tag = this.tabControl_Content.SelectedTab.Tag.ToString();
				wb.Navigate((tag == "EMPTY"?"about:blank":
					GV.temp_dir + "\\" + tag + ".xml"),ref vFlags,ref vTarget,ref vPost,ref vHeader);
			}
			catch
			{
				MessageBox.Show("Error! [wb]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
				return;
			}
		}

		private void tabControl_Content_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (this.tabControl_Content.TabCount==0)
			{
				Add_Content_Page("0");
			}
			else
			{
				this.label_Title.Text = this.tabControl_Content.SelectedTab.Text;
			}
		}

		private void toolBar_Content_ButtonClick(object sender, System.Windows.Forms.ToolBarButtonClickEventArgs e)
		{
			TabPage tabpage = this.tabControl_Content.SelectedTab;
			string tag = tabpage.Tag.ToString();
			string aid = tag.Substring (1);
			bool ex = (tag.Substring (0,1) == "E");

			switch(e.Button.Tag.ToString())
			{
				case "New":
					if (this.article_list.getSID() != 0)
					{
						string url = "http://" + GV.hostname + "/bbs/add.php?sid=" +
							this.article_list.getSID().ToString();
						try
						{
							AxSHDocVw.AxWebBrowser wb = (AxSHDocVw.AxWebBrowser)(this.tabControl_Content.SelectedTab.Controls[0]);
							object vFlags = null;
							object vTarget = null;
							object vPost = null;
							object vHeader = null;
							wb.Navigate((tag == "EMPTY"?"about:blank":
								url),ref vFlags,ref vTarget,ref vPost,ref vHeader);
						}
						catch
						{
							MessageBox.Show("Error! [wb]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
						}
					}
					break;
				case "Reply":
					if (tag != "EMPTY")
					{
						string url = "http://" + GV.hostname + "/bbs/add.php?id=" + aid;
						try
						{
							AxSHDocVw.AxWebBrowser wb = (AxSHDocVw.AxWebBrowser)(this.tabControl_Content.SelectedTab.Controls[0]);
							object vFlags = null;
							object vTarget = null;
							object vPost = null;
							object vHeader = null;
							wb.Navigate((tag == "EMPTY"?"about:blank":
								url),ref vFlags,ref vTarget,ref vPost,ref vHeader);
						}
						catch
						{
							MessageBox.Show("Error! [wb]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
						}
					}
					break;
				case "Open":
					Open_Article open_article = new Open_Article();
					long i = 0;
					try
					{
						DialogResult result = open_article.ShowDialog();
						if (result == DialogResult.OK)
						{
							i = Convert.ToInt32 (open_article.aid);
						}
					}
					catch
					{
						i=0;
						MessageBox.Show("룡","",MessageBoxButtons.OK,MessageBoxIcon.Warning);
					}
					if (i>0)
					{
						Add_Content_Page(i.ToString());
					}
					break;
				case "Refresh":
					if (tag == "EMPTY")
					{
						this.label_Title.Text = tabpage.Text = "û";
					}
					else
					{
						Article_Content article = new Article_Content();
						article.setaid(aid);
						article.setex(ex);
						article.Get_Data();

						if (!article.isCorrect())
						{
							return;
						}
						
						this.label_Title.Text = tabpage.Text = article.gettitle();
					}

					try
					{
						AxSHDocVw.AxWebBrowser wb = (AxSHDocVw.AxWebBrowser)(this.tabControl_Content.SelectedTab.Controls[0]);
						object vFlags = null;
						object vTarget = null;
						object vPost = null;
						object vHeader = null;
						wb.Navigate((tag == "EMPTY"?"about:blank":
							GV.temp_dir + "\\" + tag + ".xml"),ref vFlags,ref vTarget,ref vPost,ref vHeader);
					}
					catch
					{
						MessageBox.Show("Error! [wb]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
					}
                    break;
				case "Browser":
					if (tag != "EMPTY")
					{
						string filename = GV.temp_dir + "\\" + (ex?"E":"N") + aid + ".html";
						string url = "http://" + GV.hostname + "/viewer/show_article_html.php?id="
							+ aid + "&ex=" + (ex?"1":"0");
						try
						{
							DL_Data dl = new DL_Data(url,filename);
							dl.ShowDialog();
							if (dl.isComplete())
							{
								AxSHDocVw.AxWebBrowser wb = (AxSHDocVw.AxWebBrowser)(this.tabControl_Content.SelectedTab.Controls[0]);
								object vFlags = null;
								object vTarget = null;
								object vPost = null;
								object vHeader = null;
								wb.Navigate((tag == "EMPTY"?"about:blank":
									filename),ref vFlags,ref vTarget,ref vPost,ref vHeader);
							}
						}
						catch
						{
							MessageBox.Show("Error! [wb]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
						}
					}
					break;
				case "FullScreen":
					if (e.Button.Pushed)
					{
						this.Menu = null;
						this.panel_Guide.Visible = false;
						this.panel_Search.Visible = false;
						this.panel_List.Visible = false;
					}
					else
					{
						this.Menu = this.mainMenu_Default;
						this.panel_Guide.Visible = true;
						this.panel_Search.Visible = true;
						this.panel_List.Visible = true;
					}
					break;
				case "Close":
					this.tabControl_Content.TabPages.Remove(this.tabControl_Content.SelectedTab);
					break;
			}
		}

		private void Form_Main_Load(object sender, System.EventArgs e)
		{
			Load_TreeView_Online(this.section_filename);
			Load_TreeView_Offline(this.section_filename);
			Load_Panel_List(this.section_filename);
			Add_Content_Page("0");
			if (logo!=null)
				logo.Close();
		}

		private void menuItem_About_Click(object sender, System.EventArgs e)
		{
			About about = new About();
			about.ShowDialog();
		}

		private void menuItem_Website_Click(object sender, System.EventArgs e)
		{
			try
			{
				Process.Start("http://www.leafok.com");
			}
			catch
			{
				MessageBox.Show("޷","",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

		private void menuItem_Bug_Click(object sender, System.EventArgs e)
		{
			try
			{
				string url = "mailto:service@leafok.com?subject=Bug["
					+ Application.ProductName + Application.ProductVersion + "]";
				Process.Start(url);
			}
			catch
			{
				MessageBox.Show("޷ʼͳ","",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

		private void splitter_V_DoubleClick(object sender, System.EventArgs e)
		{
			this.panel_Guide.Width = 
				(this.splitter_V_moved?this.panel_Guide.Width * 5:this.panel_Guide.Width / 5);
			this.splitter_V_moved = (!this.splitter_V_moved);
		}

		private void tabControl_Guide_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			switch(this.tabControl_Guide.SelectedTab.Tag.ToString())
			{
				case "Online":
					foreach(TabPage tp in this.tabControl_Content.TabPages)
					{
						this.tabControl_Content.TabPages.Remove(tp);
					}
					this.panel_Search.Visible = true;
					this.panel_List.Visible = true;
					this.panel_Title.Visible = true;
					this.statusBarPanel_Position.Text = (this.article_list.getview() == "ex" ? "ժ" : "");
					break;
				case "Offline":
					foreach(TabPage tp in this.tabControl_Content.TabPages)
					{
						this.tabControl_Content.TabPages.Remove(tp);
					}
					this.panel_Search.Visible = false;
					this.panel_List.Visible = false;
					this.panel_Title.Visible = false;
					this.statusBarPanel_Position.Text = "";
					break;
			}
		}

		private void menuItem_Option_Click(object sender, System.EventArgs e)
		{
			Option option = new Option();
			if (option.ShowDialog() == DialogResult.OK)
			{
				GV.Registry_Settings(true);
			}
		}

		private void menuItem_Software_Upgrade_Click(object sender, System.EventArgs e)
		{
			string upgrade_url = "http://" + GV.hostname +
				"/viewer/check_upgrade.php?ver=" + Application.ProductVersion;
			string filename = GV.temp_dir + "\\Upgrade.xml";
			try
			{
				DL_Data dl = new DL_Data(upgrade_url,filename);
				dl.ShowDialog();
				if (dl.isComplete())
				{
					XML_DataSet update = new XML_DataSet (filename);
					DataRow row = update.dataset.Tables["Update"].Rows[0];
					if (row["Status"].ToString() == "YES")
					{
						if (MessageBox.Show("и°汾Ƿأ","",
							MessageBoxButtons.YesNo,MessageBoxIcon.Question) == DialogResult.Yes)
						{
							try
							{
								upgrade_url = "http://" + GV.hostname + row["DL_URL"].ToString();
								filename = GV.app_dir + "\\" + row["DL_URL"].ToString().Substring
									(row["DL_URL"].ToString().LastIndexOf("/")+1);
								DL_Data dl_update = new DL_Data(upgrade_url,filename);
								dl_update.ShowDialog();
								if (dl.isComplete())
								{
									try
									{
										Process.Start(filename);
										Application.Exit();
									}
									catch
									{
										MessageBox.Show("װʧ","",MessageBoxButtons.OK,MessageBoxIcon.Error);
									}
								}
							}
							catch
							{
								MessageBox.Show("ʧܣ","",MessageBoxButtons.OK,MessageBoxIcon.Error);
							}
						}
					}
					else
					{
						MessageBox.Show("Ŀǰûи°汾","",
							MessageBoxButtons.OK,MessageBoxIcon.Information);
					}
				}
			}
			catch
			{
				MessageBox.Show("汾ʧܣ","",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

		private void button_Reload_Click(object sender, System.EventArgs e)
		{
			switch (this.treeView_Offline.SelectedNode.Tag.ToString().Substring(0,1))
			{
				case "S":
					Load_Excerption(true);
					break;
			}
		}

		private int Load_Excerption()
		{
			return Load_Excerption(false);
		}

		private int Load_Excerption(bool force)
		{
			TreeNode node = this.treeView_Offline.SelectedNode;
			Excerption_Package ep = new Excerption_Package ();
			ep.setDataDir(GV.app_dir + "\\Data");
			ep.setSID(Convert.ToInt16(node.Tag.ToString().Substring(1)));
			this.statusBarPanel_Process.Text = "УԺ...";
			ep.Get_Data(force);
			this.statusBarPanel_Process.Text = "";
			if (ep.isCorrect())
			{
				this.tabControl_Content.SelectedTab.Text = node.Text;
				string filename = GV.app_dir + "\\Data\\" + 
					node.Tag.ToString().Substring(1) + "\\index.html";
				try
				{
					if (File.Exists (filename))
					{
						AxSHDocVw.AxWebBrowser wb = (AxSHDocVw.AxWebBrowser)(this.tabControl_Content.SelectedTab.Controls[0]);
						object vFlags = null;
						object vTarget = null;
						object vPost = null;
						object vHeader = null;
						wb.Navigate(filename,ref vFlags,ref vTarget,ref vPost,ref vHeader);
					}
				}
				catch
				{
					MessageBox.Show("Error! [wb]","",MessageBoxButtons.OK,MessageBoxIcon.Error);
					return -1;
				}
			}
			return 0;
		}

	}
}
